head	1.4;
access;
symbols;
locks; strict;
comment	@ * @;


1.4
date	94.11.10.01.27.30;	author rushing;	state Exp;
branches;
next	1.3;

1.3
date	94.11.09.23.01.19;	author rushing;	state Exp;
branches;
next	1.2;

1.2
date	94.11.02.10.07.40;	author jcooper;	state Exp;
branches;
next	1.1;

1.1
date	94.09.16.01.01.04;	author jcooper;	state Exp;
branches;
next	;


desc
@Smart filer: extension mapping, name shortening, etc
@


1.4
log
@reindented
@
text
@/* ------------------------------------------------------------------------
 * File handlers
 *
 * author: john s. cooper
 * sept 10, 1994
 *
 * $Id: wvfiler.c 1.3 1994/11/09 23:01:19 rushing Exp $
 */
#include <windows.h>
#include <windowsx.h>
#include "wvglob.h"
#include "winvn.h"
#pragma hdrstop
#include <io.h>					// for _access
#include <stdlib.h>				// itoa

#define MAXFILTERLEN 512

/* ------------------------------------------------------------------------
 * File/path open routines
 * jsc
 */
void							/* Set up filters */
GenerateFileFilters (HWND hParentWnd, char *filters)
{
  register int i;
  int len;
  char chReplace;

  if ((len = LoadString (hInst, IDS_FILTERSTRING, filters, MAXFILTERLEN - 1)) == 0) {
	MessageBox (hParentWnd, "No Filters Available", "String Load Failure", MB_OK);
	*filters = '\0';
  }
  else {
	chReplace = filters[len - 1];	/* grab separator */

	for (i = 0; filters[i] != '\0'; i++)
	  if (filters[i] == chReplace)
		filters[i] = '\0';
  }
}

/* ------------------------------------------------------------------------
 *  Asks for a path
 *  jsc
 */
BOOL
AskForFilePath (HWND hParentWnd, char *pathName, char *title)
{
  if (!DialogBoxParam (hInst, (LPCSTR) "WinVnSelectPath", hParentWnd, (DLGPROC) lpfnWinVnSelectPathDlg, (LPARAM) pathName))
	return (FAIL);
  strcpy (pathName, strlwr (DialogString));

  return (SUCCESS);
}

/* ------------------------------------------------------------------------
 * Asks for a filename which must exist
 */
BOOL
AskForExistingFileName (HWND hParentWnd, char *fileName, char *title)
{
  OPENFILENAME ofn;
  char szFile[MAXFILENAME];
  char filters[MAXFILTERLEN];

  GenerateFileFilters (hParentWnd, filters);

  memset (&ofn, 0, sizeof (OPENFILENAME));
  szFile[0] = '\0';
  ofn.lpstrTitle = title;
  ofn.lStructSize = sizeof (OPENFILENAME);
  ofn.hwndOwner = hParentWnd;
  ofn.lpstrFilter = filters;
  ofn.nFilterIndex = 1;
  ofn.lpstrFile = szFile;
  ofn.nMaxFile = sizeof (szFile);
  ofn.lpstrFileTitle = NULL;
  ofn.Flags = OFN_SHOWHELP | OFN_FILEMUSTEXIST;

  if (GetOpenFileName (&ofn) == 0)
	return (FAIL);
  strcpy (fileName, strlwr (szFile));
  return (SUCCESS);
}
/* ------------------------------------------------------------------------
 * Check if file name is OK based on SmartFiler settings.  If not, prompt user new name
 * Check if file already exists.  If so, prompt user OK to overwrite
 * If fileName contains a name on entry, check if it's OK, if yes-done
 */
BOOL
AskForNewFileName (HWND hParentWnd, char *fileName, char *startDir, BOOL appendOk)
{
  OPENFILENAME ofn;
  char mybuf[MAXINTERNALLINE];
  char szDirName[256];
  char szFile[256];
  BOOL valid;
  char filters[MAXFILTERLEN];

  GenerateFileFilters (hParentWnd, filters);

  /* loop while no filename, invalid filename, or file exists */
  while (fileName[0] == '\0' ||
		 (valid = VerifyFileName (fileName)) == FAIL ||
		 (!appendOk && _access (fileName, 0) == 0)) {

	/* filename valid, but file exists - ask if want to overwrite it */
	if (fileName[0] != '\0' && valid == SUCCESS) {
	  _snprintf (mybuf, MAXINTERNALLINE, "File %s exists.  OK to overwrite it?", fileName);
	  if (MessageBox (hParentWnd, mybuf, "File exists",
					  MB_YESNO | MB_DEFBUTTON2 | MB_ICONQUESTION) == IDYES)
		break;
	}

	/* Open dialog to ask user for a new file name */
	memset (&ofn, 0, sizeof (OPENFILENAME));
	if (fileName[0] != '\0')
	  _snprintf (mybuf, MAXINTERNALLINE, "Invalid file name %s. Select new name", fileName);
	else {
	  if (appendOk)
		strcpy (mybuf, "Select new file name to create/append");
	  else
		strcpy (mybuf, "Select new file name to create/overwrite");
	}
	ofn.lpstrTitle = mybuf;
	strcpy (szDirName, startDir);
	if (szDirName[0])
	  ofn.lpstrInitialDir = szDirName;
	else
	  ofn.lpstrInitialDir = NULL;

	ofn.lStructSize = sizeof (OPENFILENAME);
	ofn.hwndOwner = hParentWnd;
	ofn.lpstrFilter = filters;
	ofn.nFilterIndex = 1;
	szFile[0] = '\0';
	ofn.lpstrFile = szFile;
	ofn.nMaxFile = sizeof (szFile);
	ofn.lpstrFileTitle = NULL;
	ofn.Flags = OFN_SHOWHELP | OFN_PATHMUSTEXIST;

	if (GetOpenFileName (&ofn) == 0)
	  return (FAIL);

	strcpy (fileName, strlwr (ofn.lpstrFile));
  }
  return (SUCCESS);
}
/* ------------------------------------------------------------------------
 * Test file name is OK using SmartFiler settings
 */
BOOL
VerifyFileName (char *fileName)
{
  char *beg, *ptr;

  if ((beg = strrchr (fileName, '\\')) == NULL)
	beg = fileName;
  else
	beg++;						/* skip to after path slash */

  if ((ptr = strchr (beg, '.')) == NULL)
	if (strlen (beg) <= MaxFileNameLen)		/* no extension */
	  return (SUCCESS);

  if ((unsigned int) (ptr - beg) > MaxFileNameLen)
	return (FAIL);

  beg = ptr + 1;
#ifndef WIN32					/* multiple extensions (ok in NTFS) */
  if ((ptr = strchr (beg, '.')) != NULL)
	return (FAIL);
#endif

  if (strlen (beg) > MaxFileExtLen)		/* extension too long */
	return (FAIL);

  return (SUCCESS);
}

/* ------------------------------------------------------------------------
 * SplitFileName into path, name, ext, fullName
 * i.e. c:\windows\system\xyz.txt returns xyz.txt
 * path     --> c:\windows\system  (note no final slash)
 * name     --> xyz
 * ext      --> txt
 * fullName --> xyz.txt
 *
 * args must be pointers to buffers large enough to hold strings
 * any of args can be NULL, in which case that fileName portion is ignored
 */
void
SplitFileName (char *path, char *name, char *ext, char *fullName, char *fileName)
{
  char *start, *slash, *dot, *end;
  BOOL restoreSlash;

  start = fileName;
  end = start + strlen (fileName);


  if ((slash = strrchr (start, '\\')) == NULL) {
	/* handle case like c:abc.def (no slash) */
	if (start[1] == ':' && tolower (*start) >= 'a' && tolower (*start) <= 'z') {
	  slash = &start[2];
	  restoreSlash = FALSE;
	}
	else {
	  slash = start;			/* there is no path */
	}
  }
  else {
	*slash = '\0';				/* replace last slash with null */
	restoreSlash = TRUE;
	slash++;
  }
  if (path) {
	if (slash == start)
	  *path = '\0';
	else
	  strcpy (path, start);		/* from start to slash is the path */
  }

  if (fullName)
	strcpy (fullName, slash);

  if ((dot = strrchr (slash, '.')) == NULL) {
	dot = end;
  }
  else {
	*dot = '\0';				/* replace last dot with null */
	dot++;
  }
  if (name)
	strcpy (name, slash);		/* from after the slash to dot is the name */

  if (ext) {
	strcpy (ext, dot);			/* from after the dot to the end is the extension */
  }
  if (slash != start && restoreSlash)
	*(slash - 1) = '\\';		/* restore the slash */
  if (dot != end)
	*(dot - 1) = '.';			/* restore the dot */
}

/* useful front ends to SplitFileName */
char *
GetFileExtension (char *ext, char *fileName)
{
  SplitFileName (NULL, NULL, ext, NULL, fileName);
  return ext;
}

char *
NameWithoutPath (char *name, char *fileName)
{
  SplitFileName (NULL, NULL, NULL, name, fileName);
  return name;
}

char *
PathWithoutName (char *path, char *fileName)
{
  SplitFileName (path, NULL, NULL, NULL, fileName);
  return path;
}


/* ------------------------------------------------------------------------
 * Smartfiler: HandleDupeName 
 * check if dupe file name, and if there is, deal with it 
 * return SUCCESS if dupe and handled (fixed name in newName),or if no dupe
 * return FAIL on serious failure
 */
BOOL
HandleDupeName (HWND hParentWnd, char *fileName)
{
  char path[MAXFILENAME], name[MAXFILENAME], ext[MAXFILENAME], numStr[4];
  char newName[MAXFILENAME], namecat[MAXFILENAME];
  int i, len;

  if (_access (fileName, 0) < 0)
	return SUCCESS;

  /* we have a dupe */
  strcpy (newName, fileName);
  SplitFileName (path, name, ext, NULL, fileName);
  switch (OnDupeName) {
  case DUPE_AVOID_NONE:
	return AskForNewFileName (hParentWnd, newName, path, FALSE);
	break;

  case DUPE_AVOID_NUMBER_EXT:
	for (i = 0; i < 999; i++) {
	  _snprintf (newName, MAXFILENAME, "%s\\%s.%03d", path, name, i);
	  if (_access (newName, 0) < 0)
		break;
	}
	break;

  case DUPE_AVOID_PREPEND_NUM:
	for (i = 0; i < 999; i++) {
	  _snprintf (namecat, MAXFILENAME, "%d%s", i, name);
	  namecat[MaxFileNameLen] = '\0';
	  _snprintf (newName, MAXFILENAME, "%s\\%s.%s", path, namecat, ext);
	  if (_access (newName, 0) < 0)
		break;
	}
	break;

  case DUPE_AVOID_APPEND_NUM:
	for (i = 0; i < 999; i++) {
	  itoa (i, numStr, 10);
	  len = MaxFileNameLen - strlen (numStr);
	  if (len <= 0) {
		i = 1000;
		break;
	  }
	  name[len] = '\0';
	  _snprintf (namecat, MAXFILENAME, "%s%d", name, i);
	  namecat[MaxFileNameLen] = '\0';
	  _snprintf (newName, MAXFILENAME, "%s\\%s.%s", path, namecat, ext);
	  if (_access (newName, 0) < 0)
		break;
	}
	break;
  }
  if (i == 1000)				/* we failed to get an alternative, so ask user for help */
	return AskForNewFileName (hParentWnd, fileName, path, FALSE);
  else
	strcpy (fileName, newName);

  return TRUE;
}

/* ------------------------------------------------------------------------
 * SmartFiler: HandleLongName
 * check if given name is longer than given maxLen, and if it is, deal with it 
 * return SUCCESS if too long and handled (fixed name in newName), 
 * or if name is not too long
 * return FAIL if not handled
 */
BOOL
HandleLongName (char *name, unsigned int maxLen)
{
  char newName[MAXFILENAME];
  unsigned int skipped, len, src, dest;
  BOOL result;

  len = strlen (name);
  if (len <= maxLen)
	return SUCCESS;

  /* name too long */
  switch (OnNameTooLong) {
  case SHORTEN_NONE:
	result = FAIL;
	break;

  case SHORTEN_TRUNCATE:
	name[maxLen] = '\0';
	result = SUCCESS;
	break;

  case SHORTEN_SKIP_VOWELS:
	src = dest = skipped = 0;
	while (dest < maxLen && src < len) {
	  if (len - skipped > maxLen && strchr ("aeiou-_*!@@#$%^&*()+", name[src])) {
		skipped++;
	  }
	  else {
		newName[dest] = name[src];
		dest++;
	  }
	  src++;
	}
	newName[dest] = '\0';
	strcpy (name, newName);
	result = SUCCESS;
	break;
  }
  return result;
}

/* ------------------------------------------------------------------------
 * SmartFiler: HandleExtensionConversion
 * check if ext is in the extension mapping list, and if so,
 * replace it with the mapped ext
 */
void
HandleExtensionConversion (char *ext)
{
  register unsigned long i;
  for (i = 0L; i < ExtMapSourceList->numLines; i++) {
	if (!_stricmp (TextBlockLine (ExtMapSourceList, i), ext)) {
	  strcpy (ext, TextBlockLine (ExtMapDosList, i));
	  break;
	}
  }
}

/* ------------------------------------------------------------------------
 * SmartFiler
 * processes fileName for dupe, too long, extension conversion
 * returns SUCCESS if everything works, else FAIL
 */
BOOL
SmartFile (HWND hParentWnd, char *fileName)
{
  char newName[MAXFILENAME];
  char path[MAXFILENAME], name[MAXFILENAME], ext[MAXFILENAME];
  BOOL result, result2;

  strcpy (newName, fileName);
  SplitFileName (path, name, ext, NULL, fileName);

  if (VerifyFileName (fileName) == FAIL) {
	if (EnableExtensionConversion)
	  HandleExtensionConversion (ext);

	result = HandleLongName (name, MaxFileNameLen);
	result2 = HandleLongName (ext, MaxFileExtLen);

	_snprintf (newName, MAXFILENAME, "%s\\%s.%s", path, name, ext);

	if (result == FAIL || result2 == FAIL) {
	  AskForNewFileName (hParentWnd, newName, path, FALSE);
	}

  }
  result = HandleDupeName (hParentWnd, newName);
  strcpy (fileName, newName);
  return result;
}
@


1.3
log
@93.3 update
@
text
@d7 1
a7 1
 * $Id: wvfiler.c 1.2 1994/11/02 02:07:40 jcooper Exp $
d14 2
a15 2
#include <io.h>			// for _access
#include <stdlib.h>		// itoa
d23 1
a23 1
void	/* Set up filters */
d31 2
a32 2
    MessageBox (hParentWnd, "No Filters Available", "String Load Failure", MB_OK);
    *filters = '\0';
d35 1
a35 1
    chReplace = filters[len - 1];   /* grab separator */
d37 3
a39 3
    for (i = 0; filters[i] != '\0'; i++)
      if (filters[i] == chReplace)
   filters[i] = '\0';
d50 3
a52 3
	if (!DialogBoxParam (hInst, (LPCSTR) "WinVnSelectPath", hParentWnd, (DLGPROC) lpfnWinVnSelectPathDlg, (LPARAM)pathName))
		return (FAIL);         
	strcpy (pathName, strlwr(DialogString));
d54 1
a54 1
	return (SUCCESS);
d82 1
a82 1
    return (FAIL);
d105 2
a106 2
    (valid = VerifyFileName (fileName)) == FAIL || 
	(!appendOk && _access(fileName, 0) == 0)) {
d108 20
a127 20
    /* filename valid, but file exists - ask if want to overwrite it */
    if (fileName[0] != '\0' && valid == SUCCESS) {
      _snprintf (mybuf, MAXINTERNALLINE, "File %s exists.  OK to overwrite it?", fileName);
      if (MessageBox (hParentWnd, mybuf, "File exists",
          MB_YESNO | MB_DEFBUTTON2 | MB_ICONQUESTION) == IDYES)
         break;
    }

    /* Open dialog to ask user for a new file name */
    memset (&ofn, 0, sizeof (OPENFILENAME));
    if (fileName[0] != '\0')
      _snprintf (mybuf, MAXINTERNALLINE, "Invalid file name %s. Select new name", fileName);
    else {
       if (appendOk)
          strcpy (mybuf, "Select new file name to create/append");
       else
          strcpy (mybuf, "Select new file name to create/overwrite");
    }
    ofn.lpstrTitle = mybuf;
    strcpy (szDirName, startDir);
d129 13
a141 13
    	ofn.lpstrInitialDir = szDirName;
    else
    	ofn.lpstrInitialDir = NULL;
    	
    ofn.lStructSize = sizeof (OPENFILENAME);
    ofn.hwndOwner = hParentWnd;
    ofn.lpstrFilter = filters;
    ofn.nFilterIndex = 1;
    szFile[0] = '\0';
    ofn.lpstrFile = szFile;
    ofn.nMaxFile = sizeof (szFile);
    ofn.lpstrFileTitle = NULL;
    ofn.Flags = OFN_SHOWHELP | OFN_PATHMUSTEXIST;
d143 2
a144 2
    if (GetOpenFileName (&ofn) == 0)
      return (FAIL);
d146 1
a146 1
    strcpy (fileName, strlwr (ofn.lpstrFile));
d159 1
a159 1
    beg = fileName;
d161 1
a161 1
    beg++;        /* skip to after path slash */
d164 2
a165 2
    if (strlen (beg) <= MaxFileNameLen) /* no extension */
      return (SUCCESS);
d167 2
a168 2
  if ((unsigned int)(ptr - beg) > MaxFileNameLen)
    return (FAIL);
d170 2
a171 2
  beg = ptr + 1;     
#ifndef WIN32	/* multiple extensions (ok in NTFS) */
d173 1
a173 1
    return (FAIL);
d176 2
a177 2
  if (strlen (beg) > MaxFileExtLen)    /* extension too long */
    return (FAIL);
d194 1
a194 1
SplitFileName(char *path, char *name, char *ext, char *fullName, char *fileName)
d200 1
a200 1
  end = start + strlen(fileName);
d204 13
a216 11
     /* handle case like c:abc.def (no slash) */
	 if (start[1] == ':' && tolower(*start) >= 'a' && tolower(*start) <= 'z') {
		slash = &start[2];
        restoreSlash = FALSE;
     } else {
        slash = start;				/* there is no path */
     }
  } else {
     *slash = '\0';				/* replace last slash with null */
     restoreSlash = TRUE;
     slash++;               
d219 4
a222 4
     if (slash == start)
        *path = '\0';		
     else
        strcpy (path, start); 	/* from start to slash is the path */
d224 1
a224 1
  
d226 2
a227 2
     strcpy (fullName, slash);
  
d229 5
a233 4
     dot = end;
  } else {
     *dot = '\0';			/* replace last dot with null */
     dot++;
d236 1
a236 1
     strcpy (name, slash);	/* from after the slash to dot is the name */
d239 1
a239 1
     strcpy (ext, dot); 	/* from after the dot to the end is the extension */
d242 1
a242 1
     *(slash-1) = '\\';		/* restore the slash */
d244 1
a244 1
     *(dot-1) = '.';		/* restore the dot */
d248 2
a249 1
char *GetFileExtension (char *ext, char *fileName)
d251 1
a251 1
  SplitFileName(NULL, NULL, ext, NULL, fileName);
d255 2
a256 1
char *NameWithoutPath (char *name, char *fileName)
d258 1
a258 1
  SplitFileName(NULL, NULL, NULL, name, fileName);
d262 2
a263 1
char *PathWithoutName (char *path, char *fileName)
d265 1
a265 1
  SplitFileName(path, NULL, NULL, NULL, fileName);
d276 1
a276 1
BOOL	
d279 19
a297 14
	char path[MAXFILENAME], name[MAXFILENAME], ext[MAXFILENAME], numStr[4];
	char newName[MAXFILENAME], namecat[MAXFILENAME];
	int i, len;
	
	if (_access(fileName, 0) < 0)
		return SUCCESS;

	/* we have a dupe */
	strcpy (newName, fileName);
	SplitFileName(path, name, ext, NULL, fileName);
	switch (OnDupeName)
	{
	case DUPE_AVOID_NONE:
		return AskForNewFileName(hParentWnd, newName, path, FALSE);
d299 9
a307 7
		
	case DUPE_AVOID_NUMBER_EXT:
		for (i = 0; i < 999; i++) {
			_snprintf(newName, MAXFILENAME, "%s\\%s.%03d", path, name, i);
			if (_access(newName, 0) < 0)
				break;
		}
d309 9
a317 9
	
	case DUPE_AVOID_PREPEND_NUM:
		for (i = 0; i < 999; i++) {
			_snprintf(namecat, MAXFILENAME, "%d%s", i, name);
			namecat[MaxFileNameLen] = '\0'; 
			_snprintf(newName, MAXFILENAME, "%s\\%s.%s", path, namecat, ext);
			if (_access(newName, 0) < 0)
				break;
		}
d319 6
a324 15
								
	case DUPE_AVOID_APPEND_NUM:
		for (i = 0; i < 999; i++) {
			itoa(i, numStr, 10);
			len = MaxFileNameLen - strlen(numStr);
			if (len <= 0) {
				i = 1000; break;
			}
			name[len] = '\0';
			_snprintf(namecat, MAXFILENAME, "%s%d", name, i);
			namecat[MaxFileNameLen] = '\0'; 
			_snprintf(newName, MAXFILENAME, "%s\\%s.%s", path, namecat, ext);
			if (_access(newName, 0) < 0)
				break;
		}
d327 6
a332 4
	if (i == 1000)	/* we failed to get an alternative, so ask user for help */
		return AskForNewFileName(hParentWnd, fileName, path, FALSE);
	else
		strcpy (fileName, newName);
d334 1
a334 1
	return TRUE;	
d345 1
a345 1
HandleLongName(char *name, unsigned int maxLen)
d347 30
a376 35
	char newName[MAXFILENAME];
	unsigned int skipped, len, src, dest;
	BOOL result; 
	
	len = strlen(name);  
	if (len <= maxLen)
		return SUCCESS;
	
	/* name too long */
	switch (OnNameTooLong)
	{
	case SHORTEN_NONE:
		result = FAIL;
		break;
	
	case SHORTEN_TRUNCATE:
		name[maxLen] = '\0';
		result = SUCCESS;
        break;
        
	case SHORTEN_SKIP_VOWELS:
		src = dest = skipped = 0;
		while (dest < maxLen && src < len) {
			if (len - skipped > maxLen && strchr("aeiou-_*!@@#$%^&*()+", name[src])) {
				skipped++;	
			} else {
				newName[dest] = name[src];
				dest++;
			}
			src++;
		}
		newName[dest] = '\0';
		strcpy (name, newName);
		result = SUCCESS;
		break;
d378 6
a383 1
	return result;
d392 1
a392 1
HandleExtensionConversion(char *ext)
d394 5
a398 7
	register unsigned long i;
	for (i = 0L; i < ExtMapSourceList->numLines; i++)
	{
		if (!_stricmp(TextBlockLine(ExtMapSourceList, i), ext)) {
			strcpy(ext, TextBlockLine(ExtMapDosList, i));
			break;
		}
d400 2
a401 1
}	
d411 18
a428 21
	char newName[MAXFILENAME];
	char path[MAXFILENAME], name[MAXFILENAME], ext[MAXFILENAME];
	BOOL result, result2;

	strcpy (newName, fileName);
	SplitFileName(path, name, ext, NULL, fileName);

	if (VerifyFileName(fileName) == FAIL)
	{
		if (EnableExtensionConversion)
			HandleExtensionConversion(ext);	

		result  = HandleLongName(name, MaxFileNameLen);
		result2 = HandleLongName(ext, MaxFileExtLen);

		_snprintf(newName, MAXFILENAME, "%s\\%s.%s", path, name, ext);

		if (result == FAIL || result2 == FAIL) {
			AskForNewFileName(hParentWnd, newName, path, FALSE);
		}
		
d430 5
a434 3
	result = HandleDupeName(hParentWnd, newName);
	strcpy(fileName, newName);
	return result;
a435 1

@


1.2
log
@big changes for .93.0
@
text
@d7 1
a7 1
 * $Id: $
d197 1
d202 1
d204 7
a210 1
     slash = start;				/* there is no path */
d213 1
d238 1
a238 1
  if (slash != start)
d381 1
a381 1
 * SmartFiler: HandleExtensionCovnersion
d386 1
a386 1
HandleExtensionCovnersion(char *ext)
d416 1
a416 1
			HandleExtensionCovnersion(ext);	
@


1.1
log
@Initial revision
@
text
@d7 1
d98 1
a98 1
  BOOL retcode;
d102 2
d105 8
a112 8
    (retcode = VerifyFileName (fileName)) == FAIL || 
	(!appendOk && _access(AttachFileName, 0) == 0)) {
    if (fileName[0] != '\0' && retcode == SUCCESS) {
      /* file exists - ask if user wants to overwrite it */
      sprintf (mybuf, "File %s exists.  OK to overwrite it?", fileName);
      retcode = MessageBox (hParentWnd, mybuf, "File exists",
          MB_YESNO | MB_DEFBUTTON2 | MB_ICONQUESTION);
      if (retcode == IDYES)
d116 1
a116 1
/*      Open dialog to ask user for a new file name */
d119 1
a119 1
      sprintf (mybuf, "Invalid file name %s. Select new name", fileName);
d170 2
a171 2
#ifndef WIN32
  beg = ptr + 1;     /* multiple extensions (ok in NT)z */
d242 1
a242 1
char *NameWithoutPath (char *fullName, char *fileName)
d244 2
a245 2
  SplitFileName(NULL, NULL, NULL, fullName, fileName);
  return fullName;
d306 3
a308 3
			strcat(name, numStr);
			name[MaxFileNameLen] = '\0'; 
			_snprintf(newName, MAXFILENAME, "%s\\%s.%s", path, name, ext);
@
