head	1.2;
access;
symbols;
locks; strict;
comment	@ * @;


1.2
date	94.11.10.01.27.31;	author rushing;	state Exp;
branches;
next	1.1;

1.1
date	94.11.02.01.48.15;	author tmenshik;	state Exp;
branches;
next	;


desc
@News group filter (wildmat) support
@


1.2
log
@reindented
@
text
@/* wvfilter.c
 * author: Tom Menshik <tmenshik@@hpcvitlm.cv.hp.com>
 *
 * $Id: wvfilter.c 1.1 1994/11/02 01:48:15 tmenshik Exp $
 */
#include <windows.h>
#include <windowsx.h>
#include "wvglob.h"
#include "winvn.h"
#pragma hdrstop

#include <stdio.h>
#include <string.h>

/*****************************************************************************/
/*  function: groupok                                                        */
/*  author: Tom Menshik                                                      */
/*  date  : 12/10/93                                                         */
/*  desc: Parse the filterBuf extracting keywords. If any keyword or         */
/*        keyword/wildcard appears in the news group, then return TRUE.      */
/*        Otherwise the group does not qualify and so return FALSE.          */
/*                                                                           */
/*        The token, '|', is used to separate keyword strings.               */
/*        The token, '*', is used as a wildcard. The wildcard can only       */
/*        appear before or after the keyword.                                */
/*                                                                           */
/*        For example, this string, "rec.*|*fun*|*windsurfing" would allow   */
/*        any group that started with "rec.", had the word "fun" in it, or   */
/*        ended with the word "windsurfing".                                 */
/*                                                                           */
/*  returns: TRUE : iff the group passes through the group filter.           */
/*           FALSE: otherwise.                                               */
/*****************************************************************************/

/* modified jsc 10/25/94.  made more robust (avoid string overruns)
 * added ability to negate pattern by placing ! as first character
 * i.e. !*sports*|*   (left-to-right order implied)
 */

#define DELIMETER '|'
#define NEGATE_PATTERN '!'
#define MAXKEYLEN 256
int wildmat (char *text, char *p);

int
MatchFilter (char *group, char *filterBuf)
{
  char keyword[MAXKEYLEN];
  int i, j;

  /* add a delimter to the end of the buffer if there is none */
  i = strlen (filterBuf);
  if (filterBuf[i - 1] != DELIMETER) {
	filterBuf[i] = DELIMETER;
	filterBuf[i + 1] = '\0';
  }

  i = 0;
  j = 0;
  while (filterBuf[i] != '\0' && j < MAXKEYLEN) {
	if (filterBuf[i] == DELIMETER) {
	  keyword[j] = '\0';
	  if (keyword[0] == NEGATE_PATTERN) {
		if (wildmat (group, &keyword[1])) {
		  return (FALSE);
		}
	  }
	  else {
		if (wildmat (group, keyword)) {
		  return (TRUE);
		}
	  }
	  i++;
	  j = 0;
	  memset (keyword, 0, MAXKEYLEN);
	}
	else {
	  keyword[j] = filterBuf[i];
	  i++;
	  j++;
	}
  }

  return (FALSE);
}

#define AbORT -1

/*  $Revision: 1.1 $
   **
   **  Do shell-style pattern matching for ?, \, [], and * characters.
   **  Might not be robust in face of malformed patterns; e.g., "foo[a-"
   **  could cause a segmentation violation.  It is 8bit clean.
   **
   **  Written by Rich $alz, mirror!rs, Wed Nov 26 19:03:17 EST 1986.
   **  Rich $alz is now <rsalz@@osf.org>.
   **  April, 1991:  Replaced mutually-recursive calls with in-line code
   **  for the star character.
   **
   **  Special thanks to Lars Mathiesen <thorinn@@diku.dk> for the AbORT code.
   **  This can greatly speed up failing wildcard patterns.  For example:
   **   pattern: -*-*-*-*-*-*-12-*-*-*-m-*-*-*
   **   text 1:  -adobe-courier-bold-o-normal--12-120-75-75-m-70-iso8859-1
   **   text 2:  -adobe-courier-bold-o-normal--12-120-75-75-X-70-iso8859-1
   **  Text 1 matches with 51 calls, while text 2 fails with 54 calls.  Without
   **  the AbORT code, it takes 22310 calls to fail.  Ugh.  The following
   **  explanation is from Lars:
   **  The precondition that must be fulfilled is that DoMatch will consume
   **  at least one character in text.  This is true if *p is neither '*' nor
   **  '\0'.)  The last return has AbORT instead of FALSE to avoid quadratic
   **  behaviour in cases like pattern "*a*b*c*d" with text "abcxxxxx".  With
   **  FALSE, each star-loop has to run to the end of the text; with AbORT
   **  only the last one does.
   **
   **  Once the control of one instance of DoMatch enters the star-loop, that
   **  instance will return either TRUE or AbORT, and any calling instance
   **  will therefore return immediately after (without calling recursively
   **  again).  In effect, only one star-loop is ever active.  It would be
   **  possible to modify the code to maintain this context explicitly,
   **  eliminating all recursive calls at the cost of some complication and
   **  loss of clarity (and the AbORT stuff seems to be unclear enough by
   **  itself).  I think it would be unwise to try to get this into a
   **  released version unless you have a good test data base to try it out
   **  on.
 */

	/* What character marks an inverted character class? */
#define NEGATE_CLASS		'^'
	/* Is "*" a common pattern? */
#define OPTIMIZE_JUST_STAR
	/* Do tar(1) matching rules, which ignore a trailing slash? */
#undef MATCH_TAR_PATTERN

/*
   **  Match text and p, return TRUE, FALSE, or AbORT.
 */
static int
DoMatch (text, p)
	 register char *text;
	 register char *p;
{
  register int last;
  register int matched;
  register int reverse;

  for (; *p; text++, p++) {
	if (*text == '\0' && *p != '*')
	  return AbORT;
	switch (*p) {
	case '\\':
	  /* Literal match with following character. */
	  p++;
	  /* FALLTHROUGH */
	default:
	  if (*text != *p)
		return FALSE;
	  continue;
	case '?':
	  /* Match anything. */
	  continue;
	case '*':
	  while (*++p == '*')
		/* Consecutive stars act just like one. */
		continue;
	  if (*p == '\0')
		/* Trailing star matches everything. */
		return TRUE;
	  while (*text)
		if ((matched = DoMatch (text++, p)) != FALSE)
		  return matched;
	  return AbORT;
	case '[':
	  reverse = p[1] == NEGATE_CLASS ? TRUE : FALSE;
	  if (reverse)
		/* Inverted character class. */
		p++;
	  matched = FALSE;
	  if (p[1] == ']' || p[1] == '-')
		if (*++p == *text)
		  matched = TRUE;
	  for (last = *p; *++p && *p != ']'; last = *p)
		/* This next line requires a good C compiler. */
		if (*p == '-' && p[1] != ']'
			? *text <= *++p && *text >= last : *text == *p)
		  matched = TRUE;
	  if (matched == reverse)
		return FALSE;
	  continue;
	}
  }

#ifdef	MATCH_TAR_PATTERN
  if (*text == '/')
	return TRUE;
#endif /* MATCH_TAR_ATTERN */
  return *text == '\0';
}


/*
   **  User-level routine.  Returns TRUE or FALSE.
 */
int
wildmat (text, p)
	 char *text;
	 char *p;
{
#ifdef	OPTIMIZE_JUST_STAR
  if (p[0] == '*' && p[1] == '\0')
	return TRUE;
#endif /* OPTIMIZE_JUST_STAR */
  return DoMatch (text, p) == TRUE;
}
@


1.1
log
@Initial revision
@
text
@d4 1
a4 1
 * $Id: $
d14 1
a14 1
 
d43 1
a43 1
int wildmat(char *text, char *p);
d45 2
a46 1
int MatchFilter(char *group, char *filterBuf)
d48 2
a49 2
   char  keyword[MAXKEYLEN];
   int   i, j;
d51 32
a82 30
   /* add a delimter to the end of the buffer if there is none */
   i=strlen(filterBuf);
   if (filterBuf[i-1] != DELIMETER) {
      filterBuf[i] = DELIMETER;
      filterBuf[i+1] = '\0';
   }

   i=0;j=0;
   while (filterBuf[i] != '\0' && j < MAXKEYLEN) {
      if (filterBuf[i]==DELIMETER) {
         keyword[j]='\0';
         if (keyword[0] == NEGATE_PATTERN) {
            if (wildmat(group, &keyword[1])) {
               return(FALSE);
            }
         } else {
            if (wildmat(group,keyword)) {
               return(TRUE);
            }
         }
         i++;
         j=0;
         memset(keyword, 0, MAXKEYLEN);
      }         
      else {
         keyword[j]=filterBuf[i];
         i++;
         j++;
      }
    }
d84 1
a84 1
   return(FALSE);
d89 37
a125 37
/*  $Revision: 1.9 $
**
**  Do shell-style pattern matching for ?, \, [], and * characters.
**  Might not be robust in face of malformed patterns; e.g., "foo[a-"
**  could cause a segmentation violation.  It is 8bit clean.
**
**  Written by Rich $alz, mirror!rs, Wed Nov 26 19:03:17 EST 1986.
**  Rich $alz is now <rsalz@@osf.org>.
**  April, 1991:  Replaced mutually-recursive calls with in-line code
**  for the star character.
**
**  Special thanks to Lars Mathiesen <thorinn@@diku.dk> for the AbORT code.
**  This can greatly speed up failing wildcard patterns.  For example:
**	pattern: -*-*-*-*-*-*-12-*-*-*-m-*-*-*
**	text 1:	 -adobe-courier-bold-o-normal--12-120-75-75-m-70-iso8859-1
**	text 2:	 -adobe-courier-bold-o-normal--12-120-75-75-X-70-iso8859-1
**  Text 1 matches with 51 calls, while text 2 fails with 54 calls.  Without
**  the AbORT code, it takes 22310 calls to fail.  Ugh.  The following
**  explanation is from Lars:
**  The precondition that must be fulfilled is that DoMatch will consume
**  at least one character in text.  This is true if *p is neither '*' nor
**  '\0'.)  The last return has AbORT instead of FALSE to avoid quadratic
**  behaviour in cases like pattern "*a*b*c*d" with text "abcxxxxx".  With
**  FALSE, each star-loop has to run to the end of the text; with AbORT
**  only the last one does.
**
**  Once the control of one instance of DoMatch enters the star-loop, that
**  instance will return either TRUE or AbORT, and any calling instance
**  will therefore return immediately after (without calling recursively
**  again).  In effect, only one star-loop is ever active.  It would be
**  possible to modify the code to maintain this context explicitly,
**  eliminating all recursive calls at the cost of some complication and
**  loss of clarity (and the AbORT stuff seems to be unclear enough by
**  itself).  I think it would be unwise to try to get this into a
**  released version unless you have a good test data base to try it out
**  on.
*/
d127 1
a127 1
    /* What character marks an inverted character class? */
d129 1
a129 1
    /* Is "*" a common pattern? */
d131 1
a131 1
    /* Do tar(1) matching rules, which ignore a trailing slash? */
d135 2
a136 2
**  Match text and p, return TRUE, FALSE, or AbORT.
*/
d138 3
a140 3
DoMatch(text, p)
    register char	*text;
    register char	*p;
d142 3
a144 3
    register int	last;
    register int	matched;
    register int	reverse;
d146 1
a146 1
    for ( ; *p; text++, p++) {
d148 1
a148 1
	    return AbORT;
d151 3
a153 3
	    /* Literal match with following character. */
	    p++;
	    /* FALLTHROUGH */
d155 1
a155 1
	    if (*text != *p)
d157 1
a157 1
	    continue;
d159 2
a160 2
	    /* Match anything. */
	    continue;
d162 1
a162 1
	    while (*++p == '*')
d165 1
a165 1
	    if (*p == '\0')
d168 4
a171 4
	    while (*text)
		if ((matched = DoMatch(text++, p)) != FALSE)
		    return matched;
	    return AbORT;
d173 2
a174 2
	    reverse = p[1] == NEGATE_CLASS ? TRUE : FALSE;
	    if (reverse)
d177 2
a178 2
	    matched = FALSE;
	    if (p[1] == ']' || p[1] == '-')
d180 2
a181 2
		    matched = TRUE;
	    for (last = *p; *++p && *p != ']'; last = *p)
d184 3
a186 3
		    ? *text <= *++p && *text >= last : *text == *p)
		    matched = TRUE;
	    if (matched == reverse)
d188 1
a188 1
	    continue;
d190 1
a190 1
    }
d193 1
a193 1
    if (*text == '/')
d195 2
a196 2
#endif	/* MATCH_TAR_ATTERN */
    return *text == '\0';
d201 2
a202 2
**  User-level routine.  Returns TRUE or FALSE.
*/
d204 3
a206 3
wildmat(text, p)
    char	*text;
    char	*p;
d209 1
a209 1
    if (p[0] == '*' && p[1] == '\0')
d211 2
a212 2
#endif	/* OPTIMIZE_JUST_STAR */
    return DoMatch(text, p) == TRUE;
a213 1

@
