head	1.2;
access;
symbols;
locks; strict;
comment	@ * @;


1.2
date	94.11.10.01.27.42;	author rushing;	state Exp;
branches;
next	1.1;

1.1
date	94.11.02.01.47.36;	author jglasser;	state Exp;
branches;
next	;


desc
@Status Bar support routines
@


1.2
log
@reindented
@
text
@/* wvstbar.c
 * author: jody glasser (jglas@@tdycont.com)
 *
 * $Id: wvstbar.c 1.1 1994/11/02 01:47:36 jglasser Exp $
 */

#include <windows.h>
#include "wvglob.h"
#include "winvn.h"
#include "wvtb\wvtbi.h"

static BOOL bInKeyDown = FALSE;

/*
   These are the popups defined in the menus in winvn.rc
   Any changes to the menu definitions will require
   corresponding changes in this module.

   main window popups:     Group Window popups:    Article Window popups:
   Network                 Articles                File
   Group                   Sort                    Edit
   Utilities               Search                  Search
   Batch Send                                   View
   Config                                          Respond
   Configure Fonts
   Configure Color
   Window
   Close
   Minimize
   Help

 */


/* structure to associate popup handles to identifiers */
typedef struct popupid {
  HMENU hMenu;					/* menu handle */
  int ID;						/* corresponding identifier */
} POPUPID;

static POPUPID PopupTable[MAXPOPUPS];
static int NumPopups;
static int GroupPopupBase;
static int ArtPopupBase;

/*
 ** StatBarMainPopups
 *
 *  PARAMETERS:   none
 *
 *  CALLED:       once after creation of main window
 *
 *  DESCRIPTION:  gets HMENUs associated with the main window
 *                popups and associates them with predefined
 *                identifiers to be used in stringtable lookups
 *                to provide status bar text
 *
 *  RETURNS:      nothing
 *
 */
void
StatBarMainPopups ()
{
  HMENU hMenu;
  int i;

  hMenu = GetMenu (NetDoc.hWndFrame);
  i = 0;

  /* top level menus */
  PopupTable[i].ID = IDM_NETWORK_MENU;
  PopupTable[i].hMenu = GetSubMenu (hMenu, i);
  i++;
  PopupTable[i].ID = IDM_GROUP_MENU;
  PopupTable[i].hMenu = GetSubMenu (hMenu, i);
  i++;
  PopupTable[i].ID = IDM_UTILITIES_MENU;
  PopupTable[i].hMenu = GetSubMenu (hMenu, i);
  i++;
  PopupTable[i].ID = IDM_CONFIG_MENU;
  PopupTable[i].hMenu = GetSubMenu (hMenu, i);
  i++;
  PopupTable[i].ID = IDM_WINDOW_MENU;
  PopupTable[i].hMenu = GetSubMenu (hMenu, i);
  i++;
  PopupTable[i].ID = IDM_HELP_MENU;
  PopupTable[i].hMenu = GetSubMenu (hMenu, i);

  /* nested sub-menus */
  i++;
  PopupTable[i].ID = IDM_BATCH_MENU;
  PopupTable[i].hMenu = GetSubMenu (PopupTable[2].hMenu, 3);
  i++;
  PopupTable[i].ID = IDM_FONT_MENU;
  PopupTable[i].hMenu = GetSubMenu (PopupTable[3].hMenu, 13);
  i++;
  PopupTable[i].ID = IDM_COLOR_MENU;
  PopupTable[i].hMenu = GetSubMenu (PopupTable[3].hMenu, 14);
  i++;
  PopupTable[i].ID = IDM_CLOSE_MENU;
  PopupTable[i].hMenu = GetSubMenu (PopupTable[4].hMenu, 1);
  i++;
  PopupTable[i].ID = IDM_MINIMIZE_MENU;
  PopupTable[i].hMenu = GetSubMenu (PopupTable[4].hMenu, 2);

  NumPopups = i + 1;
  GroupPopupBase = NumPopups;
}

/*
 ** StatBarGroupPopups
 *
 *  PARAMETERS:   TypDoc *MyDoc
 *
 *  CALLED:       whenever group window gets the focus
 *
 *  DESCRIPTION:  gets HMENUs associated with the current group window
 *                popups and associates them with predefined
 *                identifiers to be used in stringtable lookups
 *                to provide status bar text
 *
 *  RETURNS:      nothing
 *
 */
void
StatBarGroupPopups (TypDoc * MyDoc)
{
  HMENU hMenu;
  int i, j;

  hMenu = GetMenu (MyDoc->hWndFrame);
  i = GroupPopupBase;
  j = 0;

  PopupTable[i].ID = IDM_ARTICLE_MENU;
  PopupTable[i].hMenu = GetSubMenu (hMenu, j);
  i++;
  j++;
  PopupTable[i].ID = IDM_SORT_MENU;
  PopupTable[i].hMenu = GetSubMenu (hMenu, j);
  i++;
  j++;
  PopupTable[i].ID = IDM_SEARCH_MENU;
  PopupTable[i].hMenu = GetSubMenu (hMenu, j);
  i++;

  if (NumPopups < i) {
	NumPopups = i;
	ArtPopupBase = i;
  }
}

/*
 ** StatBarArtPopups
 *
 *  PARAMETERS:   TypDoc *MyDoc
 *
 *  CALLED:       whenever article window gets the focus
 *
 *  DESCRIPTION:  gets HMENUs associated with the current article window
 *                popups and associates them with predefined
 *                identifiers to be used in stringtable lookups
 *                to provide status bar text
 *
 *  RETURNS:      nothing
 *
 */
void
StatBarArtPopups (TypDoc * MyDoc)
{
  HMENU hMenu;
  int i, j;

  hMenu = GetMenu (MyDoc->hWndFrame);
  i = ArtPopupBase;
  j = 0;

  PopupTable[i].ID = IDM_FILE_MENU;
  PopupTable[i].hMenu = GetSubMenu (hMenu, j);
  i++;
  j++;
  PopupTable[i].ID = IDM_EDIT_MENU;
  PopupTable[i].hMenu = GetSubMenu (hMenu, j);
  i++;
  j++;
  PopupTable[i].ID = IDM_ARTSEARCH_MENU;
  PopupTable[i].hMenu = GetSubMenu (hMenu, j);
  i++;
  j++;
  PopupTable[i].ID = IDM_VIEW_MENU;
  PopupTable[i].hMenu = GetSubMenu (hMenu, j);
  i++;
  j++;
  PopupTable[i].ID = IDM_RESPOND_MENU;
  PopupTable[i].hMenu = GetSubMenu (hMenu, j);
  i++;
  if (NumPopups < i) {
	NumPopups = i;
  }
}


/* Initialize the variables with Status Bar element sizes  */
/* call once at initialization                             */
void
InitStatBar (STATUSPAINT * StatbarPntData)
{
  HDC hDC;
  TEXTMETRIC tm;
  HANDLE hOldFont;

  StatbarPntData->dyBorder = GetSystemMetrics (SM_CYBORDER);
  StatbarPntData->dyBorderx2 = StatbarPntData->dyBorder * 2;
  StatbarPntData->dyBorderx3 = StatbarPntData->dyBorder * 3;
  StatbarPntData->dyBorderx4 = StatbarPntData->dyBorder * 4;
  StatbarPntData->dyBorderx8 = StatbarPntData->dyBorder * 8;
  StatbarPntData->dyBorderx9 = StatbarPntData->dyBorder * 9;
  StatbarPntData->dyBorderx10 = StatbarPntData->dyBorder * 10;

  hDC = GetDC (NULL);
/* 
   char          szHelv[] = "Helv";
   int           Fntheight;                  // Height of the font
   Fntheight = MulDiv(-10, GetDeviceCaps(hDC, LOGPIXELSY), 72);
   StatbarPntData->hFontStatbar = hWinVnFont;
   ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
   DEFAULT_QUALITY, VARIABLE_PITCH | FF_SWISS, szHelv);
 */
  StatbarPntData->hFontStatbar = hWinVnFont;
  hOldFont = SelectObject (hDC, StatbarPntData->hFontStatbar);
  GetTextMetrics (hDC, &tm);
  SelectObject (hDC, hOldFont);
  ReleaseDC (NULL, hDC);

  StatbarPntData->dyStatbar = tm.tmHeight + tm.tmExternalLeading + (7 * StatbarPntData->dyBorder);
  /* sb eliminated */
  StatbarPntData->dxStates = tm.tmMaxCharWidth * 3;

  StatBarMainPopups ();
}


void
SetNumLockText (HWND hwnd)
{
  RECT rc, rcTemp, rcTemp2;
  HDC hdc;
  int NumLockLeft;
  char szString[6];
  static int nLastState = FALSE;
  HANDLE hOldFont;

  /* Num Lock Text */
  if (GetKeyState (VK_NUMLOCK) & 0x0001) {
	if (nLastState == TRUE)
	  return;
	nLastState = TRUE;
	strcpy (szString, "NUM");
  }
  else {
	if (nLastState == FALSE)
	  return;
	nLastState = FALSE;
	strcpy (szString, "");
  }

  // Is stat bar stuff initialized ? if not then don't draw text
  //
  if (StatbarPntData.dyStatbar) {
	hdc = GetDC (hwnd);

	GetClientRect (hwnd, &rc);
	rc.top = rc.bottom - StatbarPntData.dyStatbar;
	NumLockLeft = rc.right - StatbarPntData.dyBorderx9 - StatbarPntData.dxStates;

	hOldFont = SelectObject (hdc, StatbarPntData.hFontStatbar);
	SetTextColor (hdc, GetSysColor (COLOR_BTNTEXT));
	SetBkColor (hdc, GetSysColor (COLOR_BTNFACE));

	rcTemp.top = rc.top + StatbarPntData.dyBorder * 4;
	rcTemp.bottom = rc.bottom - StatbarPntData.dyBorderx3;
	rcTemp.left = NumLockLeft;
	rcTemp.right = rcTemp.left + StatbarPntData.dxStates - StatbarPntData.dyBorder;

	rcTemp2 = rcTemp;

	ExtTextOut (hdc, rcTemp.left + StatbarPntData.dyBorderx2, rcTemp.top,
				ETO_OPAQUE | ETO_CLIPPED, &rcTemp2, (LPSTR) szString,
				lstrlen ((LPSTR) szString), NULL);

	SelectObject (hdc, hOldFont);
	ReleaseDC (hwnd, hdc);
  }

  return;
}

void
SetCapsLockText (HWND hwnd)
{
  RECT rc, rcTemp, rcTemp2;
  HDC hdc;
  int CapLockLeft;
  int NumLockLeft;
  char szString[6];
  static int nLastState = FALSE;
  HANDLE hOldFont;

  /* Caps Lock Text */
  if (GetKeyState (VK_CAPITAL) & 0x0001) {
	if (nLastState == TRUE)
	  return;
	nLastState = TRUE;
	strcpy (szString, "CAPS");
  }
  else {
	if (nLastState == FALSE)
	  return;
	nLastState = FALSE;
	strcpy (szString, "");
  }

  // Is stat bar stuff initialized ? if not then don't draw text
  //
  if (StatbarPntData.dyStatbar) {
	hdc = GetDC (hwnd);

	GetClientRect (hwnd, &rc);
	rc.top = rc.bottom - StatbarPntData.dyStatbar;
	NumLockLeft = rc.right - StatbarPntData.dyBorderx9 - StatbarPntData.dxStates;
	CapLockLeft = NumLockLeft - StatbarPntData.dyBorderx3 - StatbarPntData.dxStates;

	hOldFont = SelectObject (hdc, StatbarPntData.hFontStatbar);
	SetTextColor (hdc, GetSysColor (COLOR_BTNTEXT));
	SetBkColor (hdc, GetSysColor (COLOR_BTNFACE));

	rcTemp.top = rc.top + StatbarPntData.dyBorder * 4;
	rcTemp.bottom = rc.bottom - StatbarPntData.dyBorderx3;
	rcTemp.left = CapLockLeft;
	rcTemp.right = rcTemp.left + StatbarPntData.dxStates - StatbarPntData.dyBorder;

	rcTemp2 = rcTemp;

	ExtTextOut (hdc, rcTemp.left + StatbarPntData.dyBorderx2, rcTemp.top,
				ETO_OPAQUE | ETO_CLIPPED, &rcTemp2, (LPSTR) szString,
				lstrlen ((LPSTR) szString), NULL);

	SelectObject (hdc, hOldFont);
	ReleaseDC (hwnd, hdc);
  }

  return;
}

void
SetStatbarText (HWND hwnd, LPSTR lpszStatBarText, TypDoc * MyDoc, BOOL redrawflg, BOOL permflg)
{
  RECT rc, rcTemp, rcTemp2;
  HDC hdc;
  int CapLockLeft;
  int NumLockLeft;
  HANDLE hOldFont;

  if (permflg)
	strntcpy (MyDoc->szStatBarText, lpszStatBarText, MAXSTATBARTEXT - 1);

  if (redrawflg) {
	hdc = GetDC (hwnd);

	GetClientRect (hwnd, &rc);
	rc.top = rc.bottom - StatbarPntData.dyStatbar;

	rcTemp.top = rc.top + StatbarPntData.dyBorder * 4;
	rcTemp.bottom = rc.bottom - StatbarPntData.dyBorderx3;
	rcTemp.left = StatbarPntData.dyBorderx9;
	NumLockLeft = rc.right - StatbarPntData.dyBorderx9 - StatbarPntData.dxStates;
	CapLockLeft = NumLockLeft - StatbarPntData.dyBorderx3 - StatbarPntData.dxStates;

	rcTemp.right = CapLockLeft - StatbarPntData.dyBorderx9;
	rcTemp.right = CapLockLeft - StatbarPntData.dyBorderx9 - StatbarPntData.dyBorder;

	rcTemp2 = rcTemp;

	hOldFont = SelectObject (hdc, StatbarPntData.hFontStatbar);
	SetTextColor (hdc, GetSysColor (COLOR_BTNTEXT));
	SetBkColor (hdc, GetSysColor (COLOR_BTNFACE));

	ExtTextOut (hdc, rcTemp.left + StatbarPntData.dyBorderx2, rcTemp.top,
				ETO_OPAQUE | ETO_CLIPPED, &rcTemp2, lpszStatBarText,
				lstrlen (lpszStatBarText), NULL);
	SelectObject (hdc, hOldFont);
	ReleaseDC (hwnd, hdc);
  }
  return;
}

void
PaintStatbar (HWND hwnd, HDC hdc, TypDoc * MyDoc)
{
  RECT rc, rcTemp, rcTemp2;
  HBRUSH hBrush;
  int CapLockLeft;
  int NumLockLeft;
  char szString[6];
  HANDLE hOldFont;


  GetClientRect (hwnd, &rc);

  rc.top = rc.bottom - StatbarPntData.dyStatbar;
  NumLockLeft = rc.right - StatbarPntData.dyBorderx9 - StatbarPntData.dxStates;
  CapLockLeft = NumLockLeft - StatbarPntData.dyBorderx3 - StatbarPntData.dxStates;

  /* draw the frame */

  /* Border color */

  hBrush = CreateSolidBrush (GetSysColor (COLOR_BTNFACE));

  /* top and bottom border */

  /* Top */

  rcTemp = rc;
  rcTemp.bottom = rcTemp.top + StatbarPntData.dyBorderx3;
  rcTemp.top += StatbarPntData.dyBorderx2;
  FillRect (hdc, &rcTemp, hBrush);

  /* Bottom */

  rcTemp = rc;
  rcTemp.top = rcTemp.bottom - StatbarPntData.dyBorderx2;
  FillRect (hdc, &rcTemp, hBrush);

  /* left and right border */

  /* Left */

  rcTemp = rc;
  rcTemp.right = StatbarPntData.dyBorderx8;
  rcTemp.top += StatbarPntData.dyBorderx2;
  FillRect (hdc, &rcTemp, hBrush);

  /* Bar between status and Caps Lock Area */
  rcTemp.right = CapLockLeft;
  rcTemp.left = rcTemp.right - StatbarPntData.dyBorderx10;
  FillRect (hdc, &rcTemp, hBrush);

  /* Bar between Caps Lock and Num Lock Area */
  rcTemp.right = NumLockLeft;
  rcTemp.left = rcTemp.right - StatbarPntData.dyBorderx4;
  FillRect (hdc, &rcTemp, hBrush);

  /* Right */
  rcTemp.right = rc.right;
  rcTemp.left = rcTemp.right - StatbarPntData.dyBorderx10;
  FillRect (hdc, &rcTemp, hBrush);

  DeleteObject (hBrush);

  /* Shadow color */

  hBrush = CreateSolidBrush (GetSysColor (COLOR_BTNSHADOW));

  /* Top and left shadow */

  rcTemp = rc;
  rcTemp.top = rc.top + StatbarPntData.dyBorderx3;
  rcTemp.bottom = rcTemp.top + StatbarPntData.dyBorder;

  /* Top of Status */
  rcTemp.left = StatbarPntData.dyBorderx8;
  rcTemp.right = CapLockLeft - StatbarPntData.dyBorderx9;

  FillRect (hdc, &rcTemp, hBrush);

  /* Top of Caps Lock */
  rcTemp.left = CapLockLeft - StatbarPntData.dyBorder;
  rcTemp.right = rcTemp.left + StatbarPntData.dxStates;
  FillRect (hdc, &rcTemp, hBrush);

  /* Top of Num Lock  */
  rcTemp.left = NumLockLeft - StatbarPntData.dyBorder;
  rcTemp.right = rcTemp.left + StatbarPntData.dxStates;
  FillRect (hdc, &rcTemp, hBrush);

  /* Left */
  rcTemp = rc;
  rcTemp.top += StatbarPntData.dyBorderx3;
  rcTemp.bottom -= StatbarPntData.dyBorderx2;

  /* Left of bar */
  rcTemp.left = StatbarPntData.dyBorderx8;
  rcTemp.right = rcTemp.left + StatbarPntData.dyBorder;
  FillRect (hdc, &rcTemp, hBrush);

  /* Left on Bar between status and Caps Lock Area */
  rcTemp.left = CapLockLeft - StatbarPntData.dyBorder;
  rcTemp.right = rcTemp.left + StatbarPntData.dyBorder;
  FillRect (hdc, &rcTemp, hBrush);

  /* Left on Bar between Caps Lock and Num Lock Area */
  rcTemp.left = NumLockLeft - StatbarPntData.dyBorder;
  rcTemp.right = rcTemp.left + StatbarPntData.dyBorder;
  FillRect (hdc, &rcTemp, hBrush);

  DeleteObject (hBrush);

  hBrush = CreateSolidBrush (GetSysColor (COLOR_BTNHIGHLIGHT));

  /* Right, top and bottom hilight */

  rcTemp = rc;
  rcTemp.top = rc.bottom - StatbarPntData.dyBorderx3;
  rcTemp.bottom = rcTemp.top + StatbarPntData.dyBorder;

  /* Bottom of status */
  rcTemp.left = StatbarPntData.dyBorderx8;
  rcTemp.right = CapLockLeft - StatbarPntData.dyBorderx9;
  FillRect (hdc, &rcTemp, hBrush);

  /* Bottom of caps lock */
  rcTemp.left = CapLockLeft;
  rcTemp.right = rcTemp.left + StatbarPntData.dxStates;
  FillRect (hdc, &rcTemp, hBrush);

  /* Bottom of num lock */
  rcTemp.left = NumLockLeft;
  rcTemp.right = rcTemp.left + StatbarPntData.dxStates;
  FillRect (hdc, &rcTemp, hBrush);

  rcTemp = rc;
  rcTemp.top += StatbarPntData.dyBorderx3;
  rcTemp.bottom -= StatbarPntData.dyBorderx2;

  /* Right of status */
  rcTemp.left = CapLockLeft - StatbarPntData.dyBorderx9;
  rcTemp.right = rcTemp.left + StatbarPntData.dyBorder;
  FillRect (hdc, &rcTemp, hBrush);

  /* Right of caps lock */
  rcTemp.left = NumLockLeft - StatbarPntData.dyBorderx3;
  rcTemp.right = rcTemp.left + StatbarPntData.dyBorder;
  FillRect (hdc, &rcTemp, hBrush);

  /* Right of num lock */
  rcTemp.left = rc.right - StatbarPntData.dyBorderx9;
  rcTemp.right = rcTemp.left + StatbarPntData.dyBorder;
  FillRect (hdc, &rcTemp, hBrush);

  /* Across the top */
  rcTemp = rc;
  rcTemp.top += StatbarPntData.dyBorder;
  rcTemp.bottom = rcTemp.top + StatbarPntData.dyBorder;
  FillRect (hdc, &rcTemp, hBrush);

  DeleteObject (hBrush);

  /* solid black line across top */

  hBrush = CreateSolidBrush (GetSysColor (COLOR_WINDOWTEXT));
  rcTemp = rc;
  rcTemp.bottom = rcTemp.top;
  rcTemp.bottom += StatbarPntData.dyBorder;
  FillRect (hdc, &rcTemp, hBrush);
  DeleteObject (hBrush);

  /* now the text, with the button face background */

  hOldFont = SelectObject (hdc, StatbarPntData.hFontStatbar);
  SetTextColor (hdc, GetSysColor (COLOR_BTNTEXT));
  SetBkColor (hdc, GetSysColor (COLOR_BTNFACE));

  /* status Text */
  rcTemp.top = rc.top + (StatbarPntData.dyBorder * 4);
  rcTemp.bottom = rc.bottom - StatbarPntData.dyBorderx3;
  rcTemp.left = StatbarPntData.dyBorderx9;
  rcTemp.right = CapLockLeft - StatbarPntData.dyBorderx10;

  rcTemp2 = rcTemp;

  ExtTextOut (hdc, rcTemp.left + StatbarPntData.dyBorderx2, rcTemp.top,
		   ETO_OPAQUE | ETO_CLIPPED, &rcTemp2, (LPSTR) MyDoc->szStatBarText,
			  lstrlen ((LPSTR) MyDoc->szStatBarText), NULL);

  /* Caps Lock Text */
  if (GetKeyState (VK_CAPITAL) & 0x0001)
	strcpy (szString, "CAPS");
  else
	strcpy (szString, "");

  rcTemp.left = CapLockLeft;
  rcTemp.right = rcTemp.left + StatbarPntData.dxStates - StatbarPntData.dyBorder;

  rcTemp2 = rcTemp;

  ExtTextOut (hdc, rcTemp.left + StatbarPntData.dyBorderx2, rcTemp.top,
			  ETO_OPAQUE | ETO_CLIPPED, &rcTemp2, (LPSTR) szString,
			  lstrlen ((LPSTR) szString), NULL);

  /* Num Lock Text */
  if (GetKeyState (VK_NUMLOCK) & 0x0001)
	strcpy (szString, "NUM");
  else
	strcpy (szString, "");

  rcTemp.left = NumLockLeft;
  rcTemp.right = rcTemp.left + StatbarPntData.dxStates - StatbarPntData.dyBorder;

  rcTemp2 = rcTemp;

  ExtTextOut (hdc, rcTemp.left + StatbarPntData.dyBorderx2, rcTemp.top,
			  ETO_OPAQUE | ETO_CLIPPED, &rcTemp2, (LPSTR) szString,
			  lstrlen ((LPSTR) szString), NULL);

  SelectObject (hdc, hOldFont);
}

void
StatusBarProc (HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam, TypDoc * MyDoc)
{
  HWND hFrameWnd;
  char szStatBarText[256];
  int i;
#ifdef _WIN32
  HMENU hMenu;
#endif

  hFrameWnd = GetParent (hWnd);
  if (hFrameWnd == NULL)
	hFrameWnd = hWnd;

  switch (message) {
  case WM_SETFOCUS:
	SetCapsLockText (hFrameWnd);
	SetNumLockText (hFrameWnd);
	break;

  case WM_KEYUP:
	bInKeyDown = FALSE;
	break;

  case WM_KEYDOWN:
	if (!bInKeyDown) {
	  if (wParam == VK_CAPITAL)
		SetCapsLockText (hFrameWnd);
	  else if (wParam == VK_NUMLOCK)
		SetNumLockText (hFrameWnd);
	  bInKeyDown = TRUE;
	}
	break;

  case WM_MENUSELECT:
#ifdef _WIN32
	if (HIWORD (wParam) == 0xFFFF && (HMENU) lParam == NULL) {
#else
	if (LOWORD (lParam) == 0xFFFF && HIWORD (lParam) == 0) {
#endif
	  SetStatbarText (hFrameWnd, MyDoc->szStatBarText, MyDoc, TRUE, FALSE);
	  return;
	}
#ifdef _WIN32
	if (HIWORD (wParam) & MF_POPUP) {
#else
	if (LOWORD (lParam) & MF_POPUP) {
#endif
	  for (i = 0; i < NumPopups; i++) {
#ifdef _WIN32
		hMenu = GetSubMenu ((HMENU) lParam, LOWORD (wParam));
		if (PopupTable[i].hMenu == hMenu) {
#else
		if ((UINT) PopupTable[i].hMenu == (UINT) LOWORD (wParam)) {
#endif
		  if (LoadString (hInst, PopupTable[i].ID, szStatBarText, 255) != 0)
			SetStatbarText (hFrameWnd, szStatBarText, MyDoc, TRUE, FALSE);
		  else
			SetStatbarText (hFrameWnd, MyDoc->szStatBarText, MyDoc, TRUE, FALSE);
		  return;
		}
	  }
	  SetStatbarText (hFrameWnd, MyDoc->szStatBarText, MyDoc, TRUE, FALSE);
	  return;
	}
	if (LOWORD (wParam)) {
	  if (LoadString (hInst, LOWORD (wParam), szStatBarText, 255) != 0)
		SetStatbarText (hFrameWnd, szStatBarText, MyDoc, TRUE, FALSE);
	  else
		SetStatbarText (hFrameWnd, MyDoc->szStatBarText, MyDoc, TRUE, FALSE);
	}
	else
	  SetStatbarText (hFrameWnd, MyDoc->szStatBarText, MyDoc, TRUE, FALSE);

	break;

  case WM_COMMAND:
	switch (HIWORD (lParam)) {
	case TBN_BEGINDRAG:
	  if (LOWORD (lParam)) {
		if (LoadString (hInst, LOWORD (lParam), szStatBarText, 255) != 0)
		  SetStatbarText (hFrameWnd, szStatBarText, MyDoc, TRUE, FALSE);
	  }
	  break;
	case TBN_ENDDRAG:
	  SetStatbarText (hFrameWnd, MyDoc->szStatBarText, MyDoc, TRUE, FALSE);
	  break;
	}
	break;

  case WM_ENTERIDLE:
	break;
  }
}
@


1.1
log
@Initial revision
@
text
@d4 1
a4 1
 * $Id: $
d12 1
a12 1
static BOOL  bInKeyDown = FALSE;
d15 3
a17 3
These are the popups defined in the menus in winvn.rc
Any changes to the menu definitions will require
corresponding changes in this module.
d19 1
a19 1
main window popups:     Group Window popups:    Article Window popups:
d23 1
a23 1
      Batch Send                                   View
d25 2
a26 2
      Configure Fonts
      Configure Color
d28 2
a29 2
      Close
      Minimize
d32 1
a32 1
*/
d36 3
a38 3
typedef struct popupid  {
   HMENU hMenu;         /* menu handle */
   int   ID;            /* corresponding identifier */
d61 2
a62 1
void StatBarMainPopups()
d64 5
a68 2
   HMENU         hMenu;
   int           i;
d70 35
a104 2
   hMenu = GetMenu(NetDoc.hWndFrame);
   i = 0;
d106 3
a108 39
   /* top level menus */
   PopupTable[i].ID    = IDM_NETWORK_MENU;
   PopupTable[i].hMenu = GetSubMenu(hMenu, i);
   i++;
   PopupTable[i].ID    = IDM_GROUP_MENU;
   PopupTable[i].hMenu = GetSubMenu(hMenu, i);
   i++;
   PopupTable[i].ID    = IDM_UTILITIES_MENU;
   PopupTable[i].hMenu = GetSubMenu(hMenu, i);
   i++;
   PopupTable[i].ID    = IDM_CONFIG_MENU;
   PopupTable[i].hMenu = GetSubMenu(hMenu, i);
   i++;
   PopupTable[i].ID    = IDM_WINDOW_MENU;
   PopupTable[i].hMenu = GetSubMenu(hMenu, i);
   i++;
   PopupTable[i].ID    = IDM_HELP_MENU;
   PopupTable[i].hMenu = GetSubMenu(hMenu, i);
                        
   /* nested sub-menus */                        
   i++;
   PopupTable[i].ID    = IDM_BATCH_MENU;
   PopupTable[i].hMenu = GetSubMenu(PopupTable[2].hMenu, 3);
   i++;
   PopupTable[i].ID    = IDM_FONT_MENU;
   PopupTable[i].hMenu = GetSubMenu(PopupTable[3].hMenu, 13);
   i++;
   PopupTable[i].ID    = IDM_COLOR_MENU;
   PopupTable[i].hMenu = GetSubMenu(PopupTable[3].hMenu, 14);
   i++;
   PopupTable[i].ID    = IDM_CLOSE_MENU;
   PopupTable[i].hMenu = GetSubMenu(PopupTable[4].hMenu, 1);
   i++;
   PopupTable[i].ID    = IDM_MINIMIZE_MENU;
   PopupTable[i].hMenu = GetSubMenu(PopupTable[4].hMenu, 2);

   NumPopups = i + 1;
   GroupPopupBase = NumPopups;
}   
d125 2
a126 1
void StatBarGroupPopups(TypDoc *MyDoc)
d128 2
a129 2
   HMENU         hMenu;
   int           i, j;
d131 21
a151 19
   hMenu = GetMenu(MyDoc->hWndFrame);
   i = GroupPopupBase;
   j = 0;
   
   PopupTable[i].ID    = IDM_ARTICLE_MENU;
   PopupTable[i].hMenu = GetSubMenu(hMenu, j);
   i++; j++;
   PopupTable[i].ID    = IDM_SORT_MENU;
   PopupTable[i].hMenu = GetSubMenu(hMenu, j);
   i++; j++;
   PopupTable[i].ID    = IDM_SEARCH_MENU;
   PopupTable[i].hMenu = GetSubMenu(hMenu, j);
   i++;

   if (NumPopups < i) {
      NumPopups = i;
      ArtPopupBase = i;
      }
}   
d168 2
a169 1
void StatBarArtPopups(TypDoc *MyDoc)
d171 2
a172 2
   HMENU         hMenu;
   int           i, j;
d174 27
a200 23
   hMenu = GetMenu(MyDoc->hWndFrame);
   i = ArtPopupBase;
   j = 0;
   
   PopupTable[i].ID    = IDM_FILE_MENU;
   PopupTable[i].hMenu = GetSubMenu(hMenu, j);
   i++; j++;
   PopupTable[i].ID    = IDM_EDIT_MENU;
   PopupTable[i].hMenu = GetSubMenu(hMenu, j);
   i++; j++;
   PopupTable[i].ID    = IDM_ARTSEARCH_MENU;
   PopupTable[i].hMenu = GetSubMenu(hMenu, j);
   i++; j++;
   PopupTable[i].ID    = IDM_VIEW_MENU;
   PopupTable[i].hMenu = GetSubMenu(hMenu, j);
   i++; j++;
   PopupTable[i].ID    = IDM_RESPOND_MENU;
   PopupTable[i].hMenu = GetSubMenu(hMenu, j);
   i++;
   if (NumPopups < i) {
      NumPopups = i;
      }
}   
d205 2
a206 1
void InitStatBar(STATUSPAINT *StatbarPntData)
d208 11
a218 11
    HDC           hDC;
    TEXTMETRIC    tm;
    HANDLE        hOldFont;

    StatbarPntData->dyBorder   = GetSystemMetrics(SM_CYBORDER);
    StatbarPntData->dyBorderx2 = StatbarPntData->dyBorder * 2;
    StatbarPntData->dyBorderx3 = StatbarPntData->dyBorder * 3;
    StatbarPntData->dyBorderx4 = StatbarPntData->dyBorder * 4;
    StatbarPntData->dyBorderx8 = StatbarPntData->dyBorder * 8;
    StatbarPntData->dyBorderx9 = StatbarPntData->dyBorder * 9;
    StatbarPntData->dyBorderx10 = StatbarPntData->dyBorder * 10;
d220 1
a220 1
    hDC = GetDC(NULL);
d222 3
a224 7
    char          szHelv[] = "Helv";
    int           Fntheight;                  // Height of the font
    Fntheight = MulDiv(-10, GetDeviceCaps(hDC, LOGPIXELSY), 72);
	StatbarPntData->hFontStatbar = hWinVnFont;
          ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
          DEFAULT_QUALITY, VARIABLE_PITCH | FF_SWISS, szHelv);
*/
d226 12
a237 8
    hOldFont = SelectObject(hDC, StatbarPntData->hFontStatbar);
    GetTextMetrics(hDC, &tm);
    SelectObject (hDC, hOldFont);
    ReleaseDC(NULL, hDC);

    StatbarPntData->dyStatbar = tm.tmHeight + tm.tmExternalLeading + (7*StatbarPntData->dyBorder);
    /* sb eliminated */
    StatbarPntData->dxStates  = tm.tmMaxCharWidth * 3;
d239 1
a239 1
    StatBarMainPopups();
d243 2
a244 1
void SetNumLockText(HWND hwnd)
d246 48
a293 48
    RECT        rc, rcTemp, rcTemp2;
    HDC         hdc;
    int         NumLockLeft;
    char        szString[6];
    static      int nLastState = FALSE;
    HANDLE      hOldFont;

    /* Num Lock Text */
    if ( GetKeyState(VK_NUMLOCK) & 0x0001) {
       if ( nLastState == TRUE )
          return;
       nLastState = TRUE;
       strcpy(szString,"NUM");
    }
    else {
       if ( nLastState == FALSE )
          return;
       nLastState = FALSE;
       strcpy(szString,"");
    }

    // Is stat bar stuff initialized ? if not then don't draw text
    //
    if ( StatbarPntData.dyStatbar) {
        hdc = GetDC(hwnd);

        GetClientRect(hwnd, &rc);
        rc.top = rc.bottom - StatbarPntData.dyStatbar;
        NumLockLeft = rc.right - StatbarPntData.dyBorderx9 - StatbarPntData.dxStates;

        hOldFont = SelectObject(hdc, StatbarPntData.hFontStatbar);
        SetTextColor(hdc, GetSysColor(COLOR_BTNTEXT));
        SetBkColor(hdc, GetSysColor(COLOR_BTNFACE));

        rcTemp.top    = rc.top + StatbarPntData.dyBorder*4;
        rcTemp.bottom = rc.bottom - StatbarPntData.dyBorderx3;
        rcTemp.left   = NumLockLeft;
        rcTemp.right  = rcTemp.left + StatbarPntData.dxStates - StatbarPntData.dyBorder;

        rcTemp2 = rcTemp;

        ExtTextOut(hdc, rcTemp.left + StatbarPntData.dyBorderx2, rcTemp.top,
                   ETO_OPAQUE | ETO_CLIPPED, &rcTemp2, (LPSTR)szString,
                   lstrlen((LPSTR)szString), NULL);

        SelectObject (hdc, hOldFont);
        ReleaseDC(hwnd, hdc);
    }
d295 1
a295 1
    return;
d298 2
a299 1
void SetCapsLockText(HWND hwnd)
d301 50
a350 50
    RECT        rc, rcTemp, rcTemp2;
    HDC         hdc;
    int         CapLockLeft;
    int         NumLockLeft;
    char        szString[6];
    static      int nLastState = FALSE;
    HANDLE      hOldFont;

    /* Caps Lock Text */
    if ( GetKeyState(VK_CAPITAL) & 0x0001) {
       if ( nLastState == TRUE )
          return;
       nLastState = TRUE;
       strcpy(szString,"CAPS");
    }
    else {
       if ( nLastState == FALSE )
          return;
       nLastState = FALSE;
       strcpy(szString,"");
    }

    // Is stat bar stuff initialized ? if not then don't draw text
    //
    if ( StatbarPntData.dyStatbar) {
        hdc = GetDC(hwnd);

        GetClientRect(hwnd, &rc);
        rc.top = rc.bottom - StatbarPntData.dyStatbar;
        NumLockLeft = rc.right - StatbarPntData.dyBorderx9 - StatbarPntData.dxStates;
        CapLockLeft = NumLockLeft - StatbarPntData.dyBorderx3 - StatbarPntData.dxStates;

        hOldFont = SelectObject(hdc, StatbarPntData.hFontStatbar);
        SetTextColor(hdc, GetSysColor(COLOR_BTNTEXT));
        SetBkColor(hdc, GetSysColor(COLOR_BTNFACE));

        rcTemp.top    = rc.top + StatbarPntData.dyBorder*4;
        rcTemp.bottom = rc.bottom - StatbarPntData.dyBorderx3;
        rcTemp.left   = CapLockLeft;
        rcTemp.right  = rcTemp.left + StatbarPntData.dxStates - StatbarPntData.dyBorder;

        rcTemp2 = rcTemp;

        ExtTextOut(hdc, rcTemp.left + StatbarPntData.dyBorderx2, rcTemp.top,
                   ETO_OPAQUE | ETO_CLIPPED, &rcTemp2, (LPSTR)szString,
                   lstrlen((LPSTR)szString), NULL);

        SelectObject (hdc, hOldFont);
        ReleaseDC(hwnd, hdc);
    }
d352 1
a352 1
    return;
d355 2
a356 1
void SetStatbarText(HWND hwnd, LPSTR lpszStatBarText, TypDoc *MyDoc, BOOL redrawflg, BOOL permflg)
d358 37
a394 37
   RECT        rc, rcTemp, rcTemp2;
   HDC         hdc;
   int         CapLockLeft;
   int         NumLockLeft;
   HANDLE      hOldFont;

   if (permflg)
      strntcpy(MyDoc->szStatBarText, lpszStatBarText, MAXSTATBARTEXT-1);

   if (redrawflg) {
      hdc = GetDC(hwnd);

      GetClientRect(hwnd, &rc);
      rc.top = rc.bottom - StatbarPntData.dyStatbar;

      rcTemp.top    = rc.top + StatbarPntData.dyBorder*4;
      rcTemp.bottom = rc.bottom - StatbarPntData.dyBorderx3;
      rcTemp.left   = StatbarPntData.dyBorderx9;
      NumLockLeft = rc.right - StatbarPntData.dyBorderx9 - StatbarPntData.dxStates;
      CapLockLeft = NumLockLeft - StatbarPntData.dyBorderx3 - StatbarPntData.dxStates;

      rcTemp.right  = CapLockLeft - StatbarPntData.dyBorderx9;
      rcTemp.right  = CapLockLeft - StatbarPntData.dyBorderx9 - StatbarPntData.dyBorder;

      rcTemp2 = rcTemp;

      hOldFont = SelectObject(hdc, StatbarPntData.hFontStatbar);
      SetTextColor(hdc, GetSysColor(COLOR_BTNTEXT));
      SetBkColor(hdc, GetSysColor(COLOR_BTNFACE));

      ExtTextOut(hdc, rcTemp.left + StatbarPntData.dyBorderx2, rcTemp.top,
                ETO_OPAQUE | ETO_CLIPPED, &rcTemp2, lpszStatBarText,
                lstrlen(lpszStatBarText), NULL);
      SelectObject (hdc, hOldFont);
      ReleaseDC(hwnd, hdc);
      }
   return;
d397 2
a398 1
void PaintStatbar(HWND hwnd, HDC hdc, TypDoc *MyDoc)
d400 6
a405 6
    RECT        rc, rcTemp, rcTemp2;
    HBRUSH      hBrush;
    int         CapLockLeft;
    int         NumLockLeft;
    char        szString[6];
    HANDLE      hOldFont;
d408 1
a408 1
    GetClientRect(hwnd, &rc);
d410 3
a412 3
    rc.top = rc.bottom - StatbarPntData.dyStatbar;
    NumLockLeft = rc.right - StatbarPntData.dyBorderx9 - StatbarPntData.dxStates;
    CapLockLeft = NumLockLeft - StatbarPntData.dyBorderx3 - StatbarPntData.dxStates;
d414 1
a414 1
    /* draw the frame */
d416 1
a416 1
        /* Border color */
d418 1
a418 1
        hBrush = CreateSolidBrush(GetSysColor(COLOR_BTNFACE));
d420 1
a420 1
    /* top and bottom border */
d422 1
a422 1
        /* Top */
d424 4
a427 4
        rcTemp = rc;
        rcTemp.bottom = rcTemp.top + StatbarPntData.dyBorderx3;
        rcTemp.top += StatbarPntData.dyBorderx2;
        FillRect(hdc, &rcTemp, hBrush);
d429 1
a429 1
        /* Bottom */
d431 3
a433 3
        rcTemp = rc;
        rcTemp.top = rcTemp.bottom - StatbarPntData.dyBorderx2;
        FillRect(hdc, &rcTemp, hBrush);
d435 1
a435 1
    /* left and right border */
d437 1
a437 1
        /* Left */
d439 4
a442 4
        rcTemp = rc;
        rcTemp.right = StatbarPntData.dyBorderx8;
        rcTemp.top  += StatbarPntData.dyBorderx2;
        FillRect(hdc, &rcTemp, hBrush);
d444 4
a447 4
        /* Bar between status and Caps Lock Area */
        rcTemp.right = CapLockLeft;
        rcTemp.left  = rcTemp.right - StatbarPntData.dyBorderx10;
        FillRect(hdc, &rcTemp, hBrush);
d449 4
a452 4
        /* Bar between Caps Lock and Num Lock Area */
        rcTemp.right = NumLockLeft;
        rcTemp.left  = rcTemp.right - StatbarPntData.dyBorderx4;
        FillRect(hdc, &rcTemp, hBrush);
d454 4
a457 4
        /* Right */
        rcTemp.right= rc.right;
        rcTemp.left = rcTemp.right - StatbarPntData.dyBorderx10;
        FillRect(hdc, &rcTemp, hBrush);
d459 1
a459 1
        DeleteObject(hBrush);
d461 1
a461 1
    /* Shadow color */
d463 1
a463 1
        hBrush = CreateSolidBrush(GetSysColor(COLOR_BTNSHADOW));
d465 1
a465 1
    /* Top and left shadow */
d467 3
a469 3
        rcTemp = rc;
        rcTemp.top    = rc.top + StatbarPntData.dyBorderx3;
        rcTemp.bottom = rcTemp.top + StatbarPntData.dyBorder;
d471 3
a473 3
        /* Top of Status */
        rcTemp.left   = StatbarPntData.dyBorderx8;
        rcTemp.right  = CapLockLeft - StatbarPntData.dyBorderx9;
d475 1
a475 1
        FillRect(hdc, &rcTemp, hBrush);
d477 4
a480 4
        /* Top of Caps Lock */
        rcTemp.left   = CapLockLeft - StatbarPntData.dyBorder;
        rcTemp.right  = rcTemp.left + StatbarPntData.dxStates;
        FillRect(hdc, &rcTemp, hBrush);
d482 4
a485 4
        /* Top of Num Lock  */
        rcTemp.left   = NumLockLeft - StatbarPntData.dyBorder;
        rcTemp.right  = rcTemp.left + StatbarPntData.dxStates;
        FillRect(hdc, &rcTemp, hBrush);
d487 4
a490 4
        /* Left */
        rcTemp = rc;
        rcTemp.top    += StatbarPntData.dyBorderx3;
        rcTemp.bottom -= StatbarPntData.dyBorderx2;
d492 4
a495 4
        /* Left of bar */
        rcTemp.left   = StatbarPntData.dyBorderx8;
        rcTemp.right  = rcTemp.left + StatbarPntData.dyBorder;
        FillRect(hdc, &rcTemp, hBrush);
d497 4
a500 4
        /* Left on Bar between status and Caps Lock Area */
        rcTemp.left   = CapLockLeft - StatbarPntData.dyBorder;
        rcTemp.right  = rcTemp.left + StatbarPntData.dyBorder;
        FillRect(hdc, &rcTemp, hBrush);
d502 4
a505 4
        /* Left on Bar between Caps Lock and Num Lock Area */
        rcTemp.left   = NumLockLeft - StatbarPntData.dyBorder;
        rcTemp.right  = rcTemp.left + StatbarPntData.dyBorder;
        FillRect(hdc, &rcTemp, hBrush);
d507 1
a507 1
        DeleteObject(hBrush);
d509 1
a509 1
        hBrush = CreateSolidBrush(GetSysColor(COLOR_BTNHIGHLIGHT));
d511 1
a511 1
    /* Right, top and bottom hilight */
d513 3
a515 3
        rcTemp = rc;
        rcTemp.top    = rc.bottom  - StatbarPntData.dyBorderx3;
        rcTemp.bottom = rcTemp.top + StatbarPntData.dyBorder;
d517 4
a520 4
        /* Bottom of status */
        rcTemp.left   = StatbarPntData.dyBorderx8;
        rcTemp.right  = CapLockLeft - StatbarPntData.dyBorderx9;
        FillRect(hdc, &rcTemp, hBrush);
d522 4
a525 4
        /* Bottom of caps lock */
        rcTemp.left   = CapLockLeft;
        rcTemp.right  = rcTemp.left + StatbarPntData.dxStates;
        FillRect(hdc, &rcTemp, hBrush);
d527 4
a530 4
        /* Bottom of num lock */
        rcTemp.left   = NumLockLeft;
        rcTemp.right  = rcTemp.left + StatbarPntData.dxStates;
        FillRect(hdc, &rcTemp, hBrush);
d532 3
a534 3
        rcTemp = rc;
        rcTemp.top    += StatbarPntData.dyBorderx3;
        rcTemp.bottom -= StatbarPntData.dyBorderx2;
d536 4
a539 4
        /* Right of status */
        rcTemp.left   = CapLockLeft - StatbarPntData.dyBorderx9;
        rcTemp.right  = rcTemp.left + StatbarPntData.dyBorder;
        FillRect(hdc, &rcTemp, hBrush);
d541 4
a544 4
        /* Right of caps lock */
        rcTemp.left  = NumLockLeft - StatbarPntData.dyBorderx3;
        rcTemp.right = rcTemp.left + StatbarPntData.dyBorder;
        FillRect(hdc, &rcTemp, hBrush);
d546 4
a549 4
        /* Right of num lock */
        rcTemp.left  = rc.right - StatbarPntData.dyBorderx9;
        rcTemp.right = rcTemp.left + StatbarPntData.dyBorder;
        FillRect(hdc, &rcTemp, hBrush);
d551 5
a555 5
        /* Across the top */
        rcTemp = rc;
        rcTemp.top += StatbarPntData.dyBorder;
        rcTemp.bottom = rcTemp.top + StatbarPntData.dyBorder;
        FillRect(hdc, &rcTemp, hBrush);
d557 1
a557 1
        DeleteObject(hBrush);
d559 1
a559 1
    /* solid black line across top */
d561 6
a566 6
    hBrush = CreateSolidBrush(GetSysColor(COLOR_WINDOWTEXT));
    rcTemp = rc;
    rcTemp.bottom = rcTemp.top;
    rcTemp.bottom += StatbarPntData.dyBorder;
    FillRect(hdc, &rcTemp, hBrush);
    DeleteObject(hBrush);
d568 1
a568 1
    /* now the text, with the button face background */
d570 3
a572 3
    hOldFont = SelectObject(hdc, StatbarPntData.hFontStatbar);
    SetTextColor(hdc, GetSysColor(COLOR_BTNTEXT));
    SetBkColor(hdc, GetSysColor(COLOR_BTNFACE));
d574 5
a578 5
    /* status Text */
    rcTemp.top    = rc.top + (StatbarPntData.dyBorder*4);
    rcTemp.bottom = rc.bottom - StatbarPntData.dyBorderx3;
    rcTemp.left   = StatbarPntData.dyBorderx9;
    rcTemp.right  = CapLockLeft - StatbarPntData.dyBorderx10;
d580 1
a580 1
    rcTemp2 = rcTemp;
d582 3
a584 3
    ExtTextOut(hdc, rcTemp.left + StatbarPntData.dyBorderx2, rcTemp.top,
               ETO_OPAQUE | ETO_CLIPPED, &rcTemp2, (LPSTR)MyDoc->szStatBarText,
               lstrlen((LPSTR)MyDoc->szStatBarText), NULL);
d586 5
a590 5
    /* Caps Lock Text */
    if ( GetKeyState(VK_CAPITAL) & 0x0001)
       strcpy(szString,"CAPS");
    else
       strcpy(szString,"");
d592 2
a593 2
    rcTemp.left   = CapLockLeft;
    rcTemp.right  = rcTemp.left + StatbarPntData.dxStates - StatbarPntData.dyBorder;
d595 1
a595 1
    rcTemp2 = rcTemp;
d597 3
a599 3
    ExtTextOut(hdc, rcTemp.left + StatbarPntData.dyBorderx2, rcTemp.top,
               ETO_OPAQUE | ETO_CLIPPED, &rcTemp2, (LPSTR)szString,
               lstrlen((LPSTR)szString), NULL);
d601 5
a605 5
    /* Num Lock Text */
    if ( GetKeyState(VK_NUMLOCK) & 0x0001)
       strcpy(szString,"NUM");
    else
       strcpy(szString,"");
d607 2
a608 2
    rcTemp.left   = NumLockLeft;
    rcTemp.right  = rcTemp.left + StatbarPntData.dxStates - StatbarPntData.dyBorder;
d610 1
a610 1
    rcTemp2 = rcTemp;
d612 3
a614 3
    ExtTextOut(hdc, rcTemp.left + StatbarPntData.dyBorderx2, rcTemp.top,
               ETO_OPAQUE | ETO_CLIPPED, &rcTemp2, (LPSTR)szString,
               lstrlen((LPSTR)szString), NULL);
d616 1
a616 1
    SelectObject (hdc, hOldFont);
d619 2
a620 1
void StatusBarProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam, TypDoc *MyDoc)
d622 3
a624 3
   HWND hFrameWnd;
   char szStatBarText[256];
   int i;
d626 2
a627 2
   HMENU hMenu;
#endif      
d629 23
a651 23
   hFrameWnd = GetParent(hWnd);
   if (hFrameWnd == NULL)
      hFrameWnd = hWnd;

   switch (message) {
      case WM_SETFOCUS:
         SetCapsLockText(hFrameWnd);
         SetNumLockText(hFrameWnd);
         break;
                  
      case WM_KEYUP:
         bInKeyDown = FALSE;
         break;

      case WM_KEYDOWN:
         if ( !bInKeyDown ) {
            if ( wParam == VK_CAPITAL )
               SetCapsLockText(hFrameWnd);
            else if ( wParam == VK_NUMLOCK )
               SetNumLockText(hFrameWnd);
            bInKeyDown = TRUE;
            }
         break;
d653 1
a653 1
      case WM_MENUSELECT:
d655 1
a655 1
         if (HIWORD(wParam) == 0xFFFF && (HMENU)lParam == NULL)  {
d657 1
a657 1
         if (LOWORD(lParam) == 0xFFFF && HIWORD(lParam) == 0)  {
d659 3
a661 3
            SetStatbarText(hFrameWnd, MyDoc->szStatBarText, MyDoc, TRUE, FALSE);
            return;
            }
d663 1
a663 1
         if (HIWORD(wParam) & MF_POPUP)  {
d665 1
a665 1
         if (LOWORD(lParam) & MF_POPUP)  {
d667 1
a667 1
            for (i = 0; i < NumPopups; i++) {
d669 2
a670 2
               hMenu = GetSubMenu((HMENU)lParam, LOWORD(wParam));
               if (PopupTable[i].hMenu == hMenu)  {
d672 1
a672 1
               if ((UINT)PopupTable[i].hMenu == (UINT)LOWORD(wParam))  {
d674 38
a711 38
                  if ( LoadString(hInst, PopupTable[i].ID, szStatBarText, 255) != 0)
                     SetStatbarText(hFrameWnd, szStatBarText, MyDoc, TRUE, FALSE);
                  else
                     SetStatbarText(hFrameWnd, MyDoc->szStatBarText, MyDoc, TRUE, FALSE);
                  return;
                  }
               }
            SetStatbarText(hFrameWnd, MyDoc->szStatBarText, MyDoc, TRUE, FALSE);
            return;
            }
         if (LOWORD(wParam)) {
            if ( LoadString(hInst, LOWORD(wParam), szStatBarText, 255) != 0)
               SetStatbarText(hFrameWnd, szStatBarText, MyDoc, TRUE, FALSE);
            else
               SetStatbarText(hFrameWnd, MyDoc->szStatBarText, MyDoc, TRUE, FALSE);
            }
         else 
            SetStatbarText(hFrameWnd, MyDoc->szStatBarText, MyDoc, TRUE, FALSE);

         break;

      case WM_COMMAND:
         switch (HIWORD(lParam)) {
            case TBN_BEGINDRAG:
               if (LOWORD(lParam)) {
                  if ( LoadString(hInst, LOWORD(lParam), szStatBarText, 255) != 0)
                     SetStatbarText(hFrameWnd, szStatBarText, MyDoc, TRUE, FALSE);
                  }
               break;
            case TBN_ENDDRAG:
               SetStatbarText(hFrameWnd, MyDoc->szStatBarText, MyDoc, TRUE, FALSE);
               break;
            }
         break;

      case WM_ENTERIDLE:
         break;
      }
a712 2


@
